#include "chil_global.h"

#define CHIL_SQRDIFF 40
#define CLEAR_PIXEL(igate) \
  for (j=0;j<ray->ntotal;j++) *(ray->data[j]+igate) = chil_no_signal_value
#define CHIL_DIFF(answer, ifield, igate) \
   tmpfloat = \
   (*(ray->data[ifield]+igate+1))-(*(ray->data[ifield]+igate)); \
   answer=tmpfloat*tmpfloat

int
CHILRemoveNoiseDoppler(Ray *ray, float threshold)
{
  int iv1, iv2, iphi_dp;

  iv1 = CHILFindField(ray, V1);
  iv2 = CHILFindField(ray, V2);
  iphi_dp = CHILFindField(ray, PHIDP);

  if (iv1 < 0 || iv2 < 0 || iphi_dp < 0) {
    return CHIL_NOTDONE;
  }
  else {
    int i, j;
    float diff1_v2, diff1_phi_dp, tmpfloat;
    CHIL_DIFF(diff1_v2, iv2, 0);
    CHIL_DIFF(diff1_phi_dp, iphi_dp, 0);
    for (i=1 ; i < ray->ngates-1 ; ++i) {
      float diff2_v2, diff2_phi_dp;
      CHIL_DIFF(diff2_v2, iv2, i);
      CHIL_DIFF(diff2_phi_dp, iphi_dp, i);
      if (diff1_v2*CHIL_SQRDIFF + diff1_phi_dp > threshold
	  && diff2_v2*CHIL_SQRDIFF + diff2_phi_dp > threshold) {
	CLEAR_PIXEL(i);
	if (i == 1) {
	  CLEAR_PIXEL(0);
	}
	else if (i == ray->ngates-2) {
	  CLEAR_PIXEL(ray->ngates-1);
	}
      }
      diff1_v2 = diff2_v2;
      diff1_phi_dp = diff2_phi_dp;
    }
  }
  return CHIL_OK;
}

