#!/bin/bash
#
# A wrapper around chilplot, because when it does all the rasters
# in a scanning file it tends to produce a few corrupted images
#

if [ "$#" -lt 3 ]
then
    echo "This is chilplot_all.sh, a wrapper around chilplot."
    echo "The options are the same as for chilplot, except that"
    echo "only one file may be processed. The chilplot options are:"
    chilplot
    exit
fi

FILE=$1
RASTERS=$2
RASTER1=$(echo $RASTERS | awk -F- '{print $1}')
if [ ! "$RASTER1" ]
then
    RASTER1=1
fi

RASTER2=$(echo $RASTERS | awk -F- '{print $2}')
if [ ! "$RASTER2" ]
then
    RASTER2=$RASTER1
fi

shift
shift
if [ "$#" -gt 1 ]
then
    if [ ! "X$(echo $1 | cut -c1)" = "X-" ]
    then
	echo "$1 should be an argument (i.e. start with a -)"
	exit 1
    fi
fi

RASTER=$RASTER1

while [ "$RASTER" -le "$RASTER2" ]
do
    COMMAND="chilplot $FILE $RASTER $@"
    echo $COMMAND
    $COMMAND
    RASTER=$(expr $RASTER + 1)
done

